/* GENERATED FILE! DO NOT EDIT! */
#include <stdio.h>
#include <naemon/naemon.h>
#include <shared/shared.h>
#include <shared/node.h>
#include "nebev-col2key.c"

int kvvec_to_comment(struct kvvec *kvv, void *data)
{
	nebstruct_comment_data *ds;
	int i;

	ds = (nebstruct_comment_data *)data;
	for (i = 0; i < kvv->kv_pairs; i++) {
		struct key_value *kv = &kvv->kv[i];
		const struct nebev_column_code *keycode;
		char *endptr;

		keycode = nebev_col_key(kv->key, kv->key_len);
		if (!keycode) {
			printf("%s is not a valid nebevent column\n", kv->key);
			return 1 + i;
		}

		switch (keycode->code) {
		case NEBEV_COL_timestamp:
			ds->timestamp.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->timestamp.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_attr:
			ds->attr = atoi(kv->value);
			break;
		case NEBEV_COL_flags:
			ds->flags = atoi(kv->value);
			break;
		case NEBEV_COL_type:
			ds->type = atoi(kv->value);
			break;
		case NEBEV_COL_comment_type:
			ds->comment_type = atoi(kv->value);
			break;
		case NEBEV_COL_host_name:
			ds->host_name = kv->value;
			break;
		case NEBEV_COL_service_description:
			ds->service_description = kv->value;
			break;
		case NEBEV_COL_entry_time:
			ds->entry_time = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_author_name:
			ds->author_name = kv->value;
			break;
		case NEBEV_COL_comment_data:
			ds->comment_data = kv->value;
			break;
		case NEBEV_COL_persistent:
			ds->persistent = atoi(kv->value);
			break;
		case NEBEV_COL_source:
			ds->source = atoi(kv->value);
			break;
		case NEBEV_COL_entry_type:
			ds->entry_type = atoi(kv->value);
			break;
		case NEBEV_COL_expires:
			ds->expires = atoi(kv->value);
			break;
		case NEBEV_COL_expire_time:
			ds->expire_time = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_comment_id:
			ds->comment_id = strtoul(kv->value, &endptr, 10);
			break;
		default:
			printf("Unrecognized key for this event type '%s'\n", kv->key);
			return -1;
		}
	}

	return 0;
}

int kvvec_to_process(struct kvvec *kvv, void *data)
{
	nebstruct_process_data *ds;
	int i;

	ds = (nebstruct_process_data *)data;
	for (i = 0; i < kvv->kv_pairs; i++) {
		struct key_value *kv = &kvv->kv[i];
		const struct nebev_column_code *keycode;
		char *endptr;

		keycode = nebev_col_key(kv->key, kv->key_len);
		if (!keycode) {
			printf("%s is not a valid nebevent column\n", kv->key);
			return 1 + i;
		}

		switch (keycode->code) {
		case NEBEV_COL_timestamp:
			ds->timestamp.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->timestamp.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_attr:
			ds->attr = atoi(kv->value);
			break;
		case NEBEV_COL_flags:
			ds->flags = atoi(kv->value);
			break;
		case NEBEV_COL_type:
			ds->type = atoi(kv->value);
			break;
		default:
			printf("Unrecognized key for this event type '%s'\n", kv->key);
			return -1;
		}
	}

	return 0;
}

int kvvec_to_adaptive_host(struct kvvec *kvv, void *data)
{
	nebstruct_adaptive_host_data *ds;
	int i;

	ds = (nebstruct_adaptive_host_data *)data;
	for (i = 0; i < kvv->kv_pairs; i++) {
		struct key_value *kv = &kvv->kv[i];
		const struct nebev_column_code *keycode;
		char *endptr;

		keycode = nebev_col_key(kv->key, kv->key_len);
		if (!keycode) {
			printf("%s is not a valid nebevent column\n", kv->key);
			return 1 + i;
		}

		switch (keycode->code) {
		case NEBEV_COL_timestamp:
			ds->timestamp.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->timestamp.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_attr:
			ds->attr = atoi(kv->value);
			break;
		case NEBEV_COL_flags:
			ds->flags = atoi(kv->value);
			break;
		case NEBEV_COL_type:
			ds->type = atoi(kv->value);
			break;
		case NEBEV_COL_command_type:
			ds->command_type = atoi(kv->value);
			break;
		case NEBEV_COL_modified_attribute:
			ds->modified_attribute = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_modified_attributes:
			ds->modified_attributes = strtoul(kv->value, &endptr, 10);
			break;
		default:
			printf("Unrecognized key for this event type '%s'\n", kv->key);
			return -1;
		}
	}

	return 0;
}

int kvvec_to_service_status(struct kvvec *kvv, void *data)
{
	nebstruct_service_status_data *ds;
	int i;

	ds = (nebstruct_service_status_data *)data;
	for (i = 0; i < kvv->kv_pairs; i++) {
		struct key_value *kv = &kvv->kv[i];
		const struct nebev_column_code *keycode;
		char *endptr;

		keycode = nebev_col_key(kv->key, kv->key_len);
		if (!keycode) {
			printf("%s is not a valid nebevent column\n", kv->key);
			return 1 + i;
		}

		switch (keycode->code) {
		case NEBEV_COL_timestamp:
			ds->timestamp.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->timestamp.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_attr:
			ds->attr = atoi(kv->value);
			break;
		case NEBEV_COL_flags:
			ds->flags = atoi(kv->value);
			break;
		case NEBEV_COL_type:
			ds->type = atoi(kv->value);
			break;
		default:
			printf("Unrecognized key for this event type '%s'\n", kv->key);
			return -1;
		}
	}

	return 0;
}

int kvvec_to_adaptive_contact(struct kvvec *kvv, void *data)
{
	nebstruct_adaptive_contact_data *ds;
	int i;

	ds = (nebstruct_adaptive_contact_data *)data;
	for (i = 0; i < kvv->kv_pairs; i++) {
		struct key_value *kv = &kvv->kv[i];
		const struct nebev_column_code *keycode;
		char *endptr;

		keycode = nebev_col_key(kv->key, kv->key_len);
		if (!keycode) {
			printf("%s is not a valid nebevent column\n", kv->key);
			return 1 + i;
		}

		switch (keycode->code) {
		case NEBEV_COL_timestamp:
			ds->timestamp.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->timestamp.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_attr:
			ds->attr = atoi(kv->value);
			break;
		case NEBEV_COL_flags:
			ds->flags = atoi(kv->value);
			break;
		case NEBEV_COL_type:
			ds->type = atoi(kv->value);
			break;
		case NEBEV_COL_command_type:
			ds->command_type = atoi(kv->value);
			break;
		case NEBEV_COL_modified_attribute:
			ds->modified_attribute = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_modified_attributes:
			ds->modified_attributes = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_modified_host_attribute:
			ds->modified_host_attribute = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_modified_host_attributes:
			ds->modified_host_attributes = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_modified_service_attribute:
			ds->modified_service_attribute = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_modified_service_attributes:
			ds->modified_service_attributes = strtoul(kv->value, &endptr, 10);
			break;
		default:
			printf("Unrecognized key for this event type '%s'\n", kv->key);
			return -1;
		}
	}

	return 0;
}

int kvvec_to_log(struct kvvec *kvv, void *data)
{
	nebstruct_log_data *ds;
	int i;

	ds = (nebstruct_log_data *)data;
	for (i = 0; i < kvv->kv_pairs; i++) {
		struct key_value *kv = &kvv->kv[i];
		const struct nebev_column_code *keycode;
		char *endptr;

		keycode = nebev_col_key(kv->key, kv->key_len);
		if (!keycode) {
			printf("%s is not a valid nebevent column\n", kv->key);
			return 1 + i;
		}

		switch (keycode->code) {
		case NEBEV_COL_timestamp:
			ds->timestamp.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->timestamp.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_attr:
			ds->attr = atoi(kv->value);
			break;
		case NEBEV_COL_flags:
			ds->flags = atoi(kv->value);
			break;
		case NEBEV_COL_type:
			ds->type = atoi(kv->value);
			break;
		case NEBEV_COL_entry_time:
			ds->entry_time = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_data_type:
			ds->data_type = atoi(kv->value);
			break;
		case NEBEV_COL_data:
			ds->data = kv->value;
			break;
		default:
			printf("Unrecognized key for this event type '%s'\n", kv->key);
			return -1;
		}
	}

	return 0;
}

int kvvec_to_program_status(struct kvvec *kvv, void *data)
{
	nebstruct_program_status_data *ds;
	int i;

	ds = (nebstruct_program_status_data *)data;
	for (i = 0; i < kvv->kv_pairs; i++) {
		struct key_value *kv = &kvv->kv[i];
		const struct nebev_column_code *keycode;
		char *endptr;

		keycode = nebev_col_key(kv->key, kv->key_len);
		if (!keycode) {
			printf("%s is not a valid nebevent column\n", kv->key);
			return 1 + i;
		}

		switch (keycode->code) {
		case NEBEV_COL_timestamp:
			ds->timestamp.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->timestamp.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_attr:
			ds->attr = atoi(kv->value);
			break;
		case NEBEV_COL_flags:
			ds->flags = atoi(kv->value);
			break;
		case NEBEV_COL_type:
			ds->type = atoi(kv->value);
			break;
		case NEBEV_COL_program_start:
			ds->program_start = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_pid:
			ds->pid = atoi(kv->value);
			break;
		case NEBEV_COL_daemon_mode:
			ds->daemon_mode = atoi(kv->value);
			break;
		case NEBEV_COL_last_log_rotation:
			ds->last_log_rotation = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_notifications_enabled:
			ds->notifications_enabled = atoi(kv->value);
			break;
		case NEBEV_COL_active_service_checks_enabled:
			ds->active_service_checks_enabled = atoi(kv->value);
			break;
		case NEBEV_COL_passive_service_checks_enabled:
			ds->passive_service_checks_enabled = atoi(kv->value);
			break;
		case NEBEV_COL_event_handlers_enabled:
			ds->event_handlers_enabled = atoi(kv->value);
			break;
		case NEBEV_COL_flap_detection_enabled:
			ds->flap_detection_enabled = atoi(kv->value);
			break;
		case NEBEV_COL_process_performance_data:
			ds->process_performance_data = atoi(kv->value);
			break;
		case NEBEV_COL_obsess_over_hosts:
			ds->obsess_over_hosts = atoi(kv->value);
			break;
		case NEBEV_COL_obsess_over_services:
			ds->obsess_over_services = atoi(kv->value);
			break;
		case NEBEV_COL_modified_host_attributes:
			ds->modified_host_attributes = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_modified_service_attributes:
			ds->modified_service_attributes = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_global_host_event_handler:
			ds->global_host_event_handler = kv->value;
			break;
		case NEBEV_COL_global_service_event_handler:
			ds->global_service_event_handler = kv->value;
			break;
		default:
			printf("Unrecognized key for this event type '%s'\n", kv->key);
			return -1;
		}
	}

	return 0;
}

int kvvec_to_notification(struct kvvec *kvv, void *data)
{
	nebstruct_notification_data *ds;
	int i;

	ds = (nebstruct_notification_data *)data;
	for (i = 0; i < kvv->kv_pairs; i++) {
		struct key_value *kv = &kvv->kv[i];
		const struct nebev_column_code *keycode;
		char *endptr;

		keycode = nebev_col_key(kv->key, kv->key_len);
		if (!keycode) {
			printf("%s is not a valid nebevent column\n", kv->key);
			return 1 + i;
		}

		switch (keycode->code) {
		case NEBEV_COL_timestamp:
			ds->timestamp.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->timestamp.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_attr:
			ds->attr = atoi(kv->value);
			break;
		case NEBEV_COL_flags:
			ds->flags = atoi(kv->value);
			break;
		case NEBEV_COL_type:
			ds->type = atoi(kv->value);
			break;
		case NEBEV_COL_notification_type:
			ds->notification_type = atoi(kv->value);
			break;
		case NEBEV_COL_start_time:
			ds->start_time.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->start_time.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_end_time:
			ds->end_time.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->end_time.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_host_name:
			ds->host_name = kv->value;
			break;
		case NEBEV_COL_service_description:
			ds->service_description = kv->value;
			break;
		case NEBEV_COL_reason_type:
			ds->reason_type = atoi(kv->value);
			break;
		case NEBEV_COL_state:
			ds->state = atoi(kv->value);
			break;
		case NEBEV_COL_output:
			ds->output = kv->value;
			break;
		case NEBEV_COL_ack_data:
			ds->ack_data = kv->value;
			break;
		case NEBEV_COL_ack_author:
			ds->ack_author = kv->value;
			break;
		case NEBEV_COL_escalated:
			ds->escalated = atoi(kv->value);
			break;
		case NEBEV_COL_contacts_notified:
			ds->contacts_notified = atoi(kv->value);
			break;
		default:
			printf("Unrecognized key for this event type '%s'\n", kv->key);
			return -1;
		}
	}

	return 0;
}

int kvvec_to_contact_notification(struct kvvec *kvv, void *data)
{
	nebstruct_contact_notification_data *ds;
	int i;

	ds = (nebstruct_contact_notification_data *)data;
	for (i = 0; i < kvv->kv_pairs; i++) {
		struct key_value *kv = &kvv->kv[i];
		const struct nebev_column_code *keycode;
		char *endptr;

		keycode = nebev_col_key(kv->key, kv->key_len);
		if (!keycode) {
			printf("%s is not a valid nebevent column\n", kv->key);
			return 1 + i;
		}

		switch (keycode->code) {
		case NEBEV_COL_timestamp:
			ds->timestamp.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->timestamp.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_attr:
			ds->attr = atoi(kv->value);
			break;
		case NEBEV_COL_flags:
			ds->flags = atoi(kv->value);
			break;
		case NEBEV_COL_type:
			ds->type = atoi(kv->value);
			break;
		case NEBEV_COL_notification_type:
			ds->notification_type = atoi(kv->value);
			break;
		case NEBEV_COL_start_time:
			ds->start_time.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->start_time.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_end_time:
			ds->end_time.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->end_time.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_host_name:
			ds->host_name = kv->value;
			break;
		case NEBEV_COL_service_description:
			ds->service_description = kv->value;
			break;
		case NEBEV_COL_contact_name:
			ds->contact_name = kv->value;
			break;
		case NEBEV_COL_reason_type:
			ds->reason_type = atoi(kv->value);
			break;
		case NEBEV_COL_state:
			ds->state = atoi(kv->value);
			break;
		case NEBEV_COL_output:
			ds->output = kv->value;
			break;
		case NEBEV_COL_ack_author:
			ds->ack_author = kv->value;
			break;
		case NEBEV_COL_ack_data:
			ds->ack_data = kv->value;
			break;
		case NEBEV_COL_escalated:
			ds->escalated = atoi(kv->value);
			break;
		default:
			printf("Unrecognized key for this event type '%s'\n", kv->key);
			return -1;
		}
	}

	return 0;
}

int kvvec_to_adaptive_service(struct kvvec *kvv, void *data)
{
	nebstruct_adaptive_service_data *ds;
	int i;

	ds = (nebstruct_adaptive_service_data *)data;
	for (i = 0; i < kvv->kv_pairs; i++) {
		struct key_value *kv = &kvv->kv[i];
		const struct nebev_column_code *keycode;
		char *endptr;

		keycode = nebev_col_key(kv->key, kv->key_len);
		if (!keycode) {
			printf("%s is not a valid nebevent column\n", kv->key);
			return 1 + i;
		}

		switch (keycode->code) {
		case NEBEV_COL_timestamp:
			ds->timestamp.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->timestamp.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_attr:
			ds->attr = atoi(kv->value);
			break;
		case NEBEV_COL_flags:
			ds->flags = atoi(kv->value);
			break;
		case NEBEV_COL_type:
			ds->type = atoi(kv->value);
			break;
		case NEBEV_COL_command_type:
			ds->command_type = atoi(kv->value);
			break;
		case NEBEV_COL_modified_attribute:
			ds->modified_attribute = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_modified_attributes:
			ds->modified_attributes = strtoul(kv->value, &endptr, 10);
			break;
		default:
			printf("Unrecognized key for this event type '%s'\n", kv->key);
			return -1;
		}
	}

	return 0;
}

int kvvec_to_external_command(struct kvvec *kvv, void *data)
{
	nebstruct_external_command_data *ds;
	int i;

	ds = (nebstruct_external_command_data *)data;
	for (i = 0; i < kvv->kv_pairs; i++) {
		struct key_value *kv = &kvv->kv[i];
		const struct nebev_column_code *keycode;
		char *endptr;

		keycode = nebev_col_key(kv->key, kv->key_len);
		if (!keycode) {
			printf("%s is not a valid nebevent column\n", kv->key);
			return 1 + i;
		}

		switch (keycode->code) {
		case NEBEV_COL_timestamp:
			ds->timestamp.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->timestamp.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_attr:
			ds->attr = atoi(kv->value);
			break;
		case NEBEV_COL_flags:
			ds->flags = atoi(kv->value);
			break;
		case NEBEV_COL_type:
			ds->type = atoi(kv->value);
			break;
		case NEBEV_COL_command_type:
			ds->command_type = atoi(kv->value);
			break;
		case NEBEV_COL_entry_time:
			ds->entry_time = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_command_string:
			ds->command_string = kv->value;
			break;
		case NEBEV_COL_command_args:
			ds->command_args = kv->value;
			break;
		default:
			printf("Unrecognized key for this event type '%s'\n", kv->key);
			return -1;
		}
	}

	return 0;
}

int kvvec_to_adaptive_program(struct kvvec *kvv, void *data)
{
	nebstruct_adaptive_program_data *ds;
	int i;

	ds = (nebstruct_adaptive_program_data *)data;
	for (i = 0; i < kvv->kv_pairs; i++) {
		struct key_value *kv = &kvv->kv[i];
		const struct nebev_column_code *keycode;
		char *endptr;

		keycode = nebev_col_key(kv->key, kv->key_len);
		if (!keycode) {
			printf("%s is not a valid nebevent column\n", kv->key);
			return 1 + i;
		}

		switch (keycode->code) {
		case NEBEV_COL_timestamp:
			ds->timestamp.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->timestamp.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_attr:
			ds->attr = atoi(kv->value);
			break;
		case NEBEV_COL_flags:
			ds->flags = atoi(kv->value);
			break;
		case NEBEV_COL_type:
			ds->type = atoi(kv->value);
			break;
		case NEBEV_COL_command_type:
			ds->command_type = atoi(kv->value);
			break;
		case NEBEV_COL_modified_host_attribute:
			ds->modified_host_attribute = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_modified_host_attributes:
			ds->modified_host_attributes = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_modified_service_attribute:
			ds->modified_service_attribute = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_modified_service_attributes:
			ds->modified_service_attributes = strtoul(kv->value, &endptr, 10);
			break;
		default:
			printf("Unrecognized key for this event type '%s'\n", kv->key);
			return -1;
		}
	}

	return 0;
}

int kvvec_to_system_command(struct kvvec *kvv, void *data)
{
	nebstruct_system_command_data *ds;
	int i;

	ds = (nebstruct_system_command_data *)data;
	for (i = 0; i < kvv->kv_pairs; i++) {
		struct key_value *kv = &kvv->kv[i];
		const struct nebev_column_code *keycode;
		char *endptr;

		keycode = nebev_col_key(kv->key, kv->key_len);
		if (!keycode) {
			printf("%s is not a valid nebevent column\n", kv->key);
			return 1 + i;
		}

		switch (keycode->code) {
		case NEBEV_COL_timestamp:
			ds->timestamp.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->timestamp.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_attr:
			ds->attr = atoi(kv->value);
			break;
		case NEBEV_COL_flags:
			ds->flags = atoi(kv->value);
			break;
		case NEBEV_COL_type:
			ds->type = atoi(kv->value);
			break;
		case NEBEV_COL_start_time:
			ds->start_time.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->start_time.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_end_time:
			ds->end_time.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->end_time.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_timeout:
			ds->timeout = atoi(kv->value);
			break;
		case NEBEV_COL_command_line:
			ds->command_line = kv->value;
			break;
		case NEBEV_COL_early_timeout:
			ds->early_timeout = atoi(kv->value);
			break;
		case NEBEV_COL_execution_time:
			ds->execution_time = strtod(kv->value, &endptr);
			break;
		case NEBEV_COL_return_code:
			ds->return_code = atoi(kv->value);
			break;
		case NEBEV_COL_output:
			ds->output = kv->value;
			break;
		default:
			printf("Unrecognized key for this event type '%s'\n", kv->key);
			return -1;
		}
	}

	return 0;
}

int kvvec_to_timed_event(struct kvvec *kvv, void *data)
{
	nebstruct_timed_event_data *ds;
	int i;

	ds = (nebstruct_timed_event_data *)data;
	for (i = 0; i < kvv->kv_pairs; i++) {
		struct key_value *kv = &kvv->kv[i];
		const struct nebev_column_code *keycode;
		char *endptr;

		keycode = nebev_col_key(kv->key, kv->key_len);
		if (!keycode) {
			printf("%s is not a valid nebevent column\n", kv->key);
			return 1 + i;
		}

		switch (keycode->code) {
		case NEBEV_COL_timestamp:
			ds->timestamp.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->timestamp.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_attr:
			ds->attr = atoi(kv->value);
			break;
		case NEBEV_COL_flags:
			ds->flags = atoi(kv->value);
			break;
		case NEBEV_COL_type:
			ds->type = atoi(kv->value);
			break;
		case NEBEV_COL_event_type:
			ds->event_type = atoi(kv->value);
			break;
		case NEBEV_COL_recurring:
			ds->recurring = atoi(kv->value);
			break;
		case NEBEV_COL_run_time:
			ds->run_time = strtoul(kv->value, &endptr, 10);
			break;
		default:
			printf("Unrecognized key for this event type '%s'\n", kv->key);
			return -1;
		}
	}

	return 0;
}

int kvvec_to_event_handler(struct kvvec *kvv, void *data)
{
	nebstruct_event_handler_data *ds;
	int i;

	ds = (nebstruct_event_handler_data *)data;
	for (i = 0; i < kvv->kv_pairs; i++) {
		struct key_value *kv = &kvv->kv[i];
		const struct nebev_column_code *keycode;
		char *endptr;

		keycode = nebev_col_key(kv->key, kv->key_len);
		if (!keycode) {
			printf("%s is not a valid nebevent column\n", kv->key);
			return 1 + i;
		}

		switch (keycode->code) {
		case NEBEV_COL_timestamp:
			ds->timestamp.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->timestamp.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_attr:
			ds->attr = atoi(kv->value);
			break;
		case NEBEV_COL_flags:
			ds->flags = atoi(kv->value);
			break;
		case NEBEV_COL_type:
			ds->type = atoi(kv->value);
			break;
		case NEBEV_COL_eventhandler_type:
			ds->eventhandler_type = atoi(kv->value);
			break;
		case NEBEV_COL_host_name:
			ds->host_name = kv->value;
			break;
		case NEBEV_COL_service_description:
			ds->service_description = kv->value;
			break;
		case NEBEV_COL_state_type:
			ds->state_type = atoi(kv->value);
			break;
		case NEBEV_COL_state:
			ds->state = atoi(kv->value);
			break;
		case NEBEV_COL_timeout:
			ds->timeout = atoi(kv->value);
			break;
		case NEBEV_COL_command_name:
			ds->command_name = kv->value;
			break;
		case NEBEV_COL_command_args:
			ds->command_args = kv->value;
			break;
		case NEBEV_COL_command_line:
			ds->command_line = kv->value;
			break;
		case NEBEV_COL_start_time:
			ds->start_time.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->start_time.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_end_time:
			ds->end_time.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->end_time.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_early_timeout:
			ds->early_timeout = atoi(kv->value);
			break;
		case NEBEV_COL_execution_time:
			ds->execution_time = strtod(kv->value, &endptr);
			break;
		case NEBEV_COL_return_code:
			ds->return_code = atoi(kv->value);
			break;
		case NEBEV_COL_output:
			ds->output = kv->value;
			break;
		default:
			printf("Unrecognized key for this event type '%s'\n", kv->key);
			return -1;
		}
	}

	return 0;
}

int kvvec_to_contact_notification_method(struct kvvec *kvv, void *data)
{
	nebstruct_contact_notification_method_data *ds;
	int i;

	ds = (nebstruct_contact_notification_method_data *)data;
	for (i = 0; i < kvv->kv_pairs; i++) {
		struct key_value *kv = &kvv->kv[i];
		const struct nebev_column_code *keycode;
		char *endptr;

		keycode = nebev_col_key(kv->key, kv->key_len);
		if (!keycode) {
			printf("%s is not a valid nebevent column\n", kv->key);
			return 1 + i;
		}

		switch (keycode->code) {
		case NEBEV_COL_timestamp:
			ds->timestamp.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->timestamp.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_attr:
			ds->attr = atoi(kv->value);
			break;
		case NEBEV_COL_flags:
			ds->flags = atoi(kv->value);
			break;
		case NEBEV_COL_type:
			ds->type = atoi(kv->value);
			break;
		case NEBEV_COL_notification_type:
			ds->notification_type = atoi(kv->value);
			break;
		case NEBEV_COL_start_time:
			ds->start_time.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->start_time.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_end_time:
			ds->end_time.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->end_time.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_host_name:
			ds->host_name = kv->value;
			break;
		case NEBEV_COL_service_description:
			ds->service_description = kv->value;
			break;
		case NEBEV_COL_contact_name:
			ds->contact_name = kv->value;
			break;
		case NEBEV_COL_reason_type:
			ds->reason_type = atoi(kv->value);
			break;
		case NEBEV_COL_command_name:
			ds->command_name = kv->value;
			break;
		case NEBEV_COL_command_args:
			ds->command_args = kv->value;
			break;
		case NEBEV_COL_state:
			ds->state = atoi(kv->value);
			break;
		case NEBEV_COL_output:
			ds->output = kv->value;
			break;
		case NEBEV_COL_ack_author:
			ds->ack_author = kv->value;
			break;
		case NEBEV_COL_ack_data:
			ds->ack_data = kv->value;
			break;
		case NEBEV_COL_escalated:
			ds->escalated = atoi(kv->value);
			break;
		default:
			printf("Unrecognized key for this event type '%s'\n", kv->key);
			return -1;
		}
	}

	return 0;
}

int kvvec_to_flapping(struct kvvec *kvv, void *data)
{
	nebstruct_flapping_data *ds;
	int i;

	ds = (nebstruct_flapping_data *)data;
	for (i = 0; i < kvv->kv_pairs; i++) {
		struct key_value *kv = &kvv->kv[i];
		const struct nebev_column_code *keycode;
		char *endptr;

		keycode = nebev_col_key(kv->key, kv->key_len);
		if (!keycode) {
			printf("%s is not a valid nebevent column\n", kv->key);
			return 1 + i;
		}

		switch (keycode->code) {
		case NEBEV_COL_timestamp:
			ds->timestamp.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->timestamp.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_attr:
			ds->attr = atoi(kv->value);
			break;
		case NEBEV_COL_flags:
			ds->flags = atoi(kv->value);
			break;
		case NEBEV_COL_type:
			ds->type = atoi(kv->value);
			break;
		case NEBEV_COL_flapping_type:
			ds->flapping_type = atoi(kv->value);
			break;
		case NEBEV_COL_host_name:
			ds->host_name = kv->value;
			break;
		case NEBEV_COL_service_description:
			ds->service_description = kv->value;
			break;
		case NEBEV_COL_percent_change:
			ds->percent_change = strtod(kv->value, &endptr);
			break;
		case NEBEV_COL_high_threshold:
			ds->high_threshold = strtod(kv->value, &endptr);
			break;
		case NEBEV_COL_low_threshold:
			ds->low_threshold = strtod(kv->value, &endptr);
			break;
		case NEBEV_COL_comment_id:
			ds->comment_id = strtoul(kv->value, &endptr, 10);
			break;
		default:
			printf("Unrecognized key for this event type '%s'\n", kv->key);
			return -1;
		}
	}

	return 0;
}

int kvvec_to_downtime(struct kvvec *kvv, void *data)
{
	nebstruct_downtime_data *ds;
	int i;

	ds = (nebstruct_downtime_data *)data;
	for (i = 0; i < kvv->kv_pairs; i++) {
		struct key_value *kv = &kvv->kv[i];
		const struct nebev_column_code *keycode;
		char *endptr;

		keycode = nebev_col_key(kv->key, kv->key_len);
		if (!keycode) {
			printf("%s is not a valid nebevent column\n", kv->key);
			return 1 + i;
		}

		switch (keycode->code) {
		case NEBEV_COL_timestamp:
			ds->timestamp.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->timestamp.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_attr:
			ds->attr = atoi(kv->value);
			break;
		case NEBEV_COL_flags:
			ds->flags = atoi(kv->value);
			break;
		case NEBEV_COL_type:
			ds->type = atoi(kv->value);
			break;
		case NEBEV_COL_downtime_type:
			ds->downtime_type = atoi(kv->value);
			break;
		case NEBEV_COL_host_name:
			ds->host_name = kv->value;
			break;
		case NEBEV_COL_service_description:
			ds->service_description = kv->value;
			break;
		case NEBEV_COL_entry_time:
			ds->entry_time = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_author_name:
			ds->author_name = kv->value;
			break;
		case NEBEV_COL_comment_data:
			ds->comment_data = kv->value;
			break;
		case NEBEV_COL_start_time:
			ds->start_time = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_end_time:
			ds->end_time = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_fixed:
			ds->fixed = atoi(kv->value);
			break;
		case NEBEV_COL_duration:
			ds->duration = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_triggered_by:
			ds->triggered_by = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_downtime_id:
			ds->downtime_id = strtoul(kv->value, &endptr, 10);
			break;
		default:
			printf("Unrecognized key for this event type '%s'\n", kv->key);
			return -1;
		}
	}

	return 0;
}

int kvvec_to_merlin_host_status(struct kvvec *kvv, void *data)
{
	merlin_host_status *ds;
	int i;

	ds = (merlin_host_status *)data;
	for (i = 0; i < kvv->kv_pairs; i++) {
		struct key_value *kv = &kvv->kv[i];
		const struct nebev_column_code *keycode;
		char *endptr;

		keycode = nebev_col_key(kv->key, kv->key_len);
		if (!keycode) {
			printf("%s is not a valid nebevent column\n", kv->key);
			return 1 + i;
		}

		switch (keycode->code) {
		case NEBEV_COL_nebattr:
			ds->nebattr = atoi(kv->value);
			break;
		case NEBEV_COL_state_initial_state:
			ds->state.initial_state = atoi(kv->value);
			break;
		case NEBEV_COL_state_flap_detection_enabled:
			ds->state.flap_detection_enabled = atoi(kv->value);
			break;
		case NEBEV_COL_state_low_flap_threshold:
			ds->state.low_flap_threshold = strtod(kv->value, &endptr);
			break;
		case NEBEV_COL_state_high_flap_threshold:
			ds->state.high_flap_threshold = strtod(kv->value, &endptr);
			break;
		case NEBEV_COL_state_check_freshness:
			ds->state.check_freshness = atoi(kv->value);
			break;
		case NEBEV_COL_state_freshness_threshold:
			ds->state.freshness_threshold = atoi(kv->value);
			break;
		case NEBEV_COL_state_process_performance_data:
			ds->state.process_performance_data = atoi(kv->value);
			break;
		case NEBEV_COL_state_checks_enabled:
			ds->state.checks_enabled = atoi(kv->value);
			break;
		case NEBEV_COL_state_accept_passive_checks:
			ds->state.accept_passive_checks = atoi(kv->value);
			break;
		case NEBEV_COL_state_event_handler_enabled:
			ds->state.event_handler_enabled = atoi(kv->value);
			break;
		case NEBEV_COL_state_obsess:
			ds->state.obsess = atoi(kv->value);
			break;
		case NEBEV_COL_state_problem_has_been_acknowledged:
			ds->state.problem_has_been_acknowledged = atoi(kv->value);
			break;
		case NEBEV_COL_state_acknowledgement_type:
			ds->state.acknowledgement_type = atoi(kv->value);
			break;
		case NEBEV_COL_state_check_type:
			ds->state.check_type = atoi(kv->value);
			break;
		case NEBEV_COL_state_current_state:
			ds->state.current_state = atoi(kv->value);
			break;
		case NEBEV_COL_state_last_state:
			ds->state.last_state = atoi(kv->value);
			break;
		case NEBEV_COL_state_last_hard_state:
			ds->state.last_hard_state = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_type:
			ds->state.state_type = atoi(kv->value);
			break;
		case NEBEV_COL_state_current_attempt:
			ds->state.current_attempt = atoi(kv->value);
			break;
		case NEBEV_COL_state_hourly_value:
			ds->state.hourly_value = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_state_current_event_id:
			ds->state.current_event_id = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_state_last_event_id:
			ds->state.last_event_id = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_state_current_problem_id:
			ds->state.current_problem_id = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_state_last_problem_id:
			ds->state.last_problem_id = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_state_latency:
			ds->state.latency = strtod(kv->value, &endptr);
			break;
		case NEBEV_COL_state_execution_time:
			ds->state.execution_time = strtod(kv->value, &endptr);
			break;
		case NEBEV_COL_state_notifications_enabled:
			ds->state.notifications_enabled = atoi(kv->value);
			break;
		case NEBEV_COL_state_last_notification:
			ds->state.last_notification = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_state_next_notification:
			ds->state.next_notification = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_state_next_check:
			ds->state.next_check = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_state_should_be_scheduled:
			ds->state.should_be_scheduled = atoi(kv->value);
			break;
		case NEBEV_COL_state_last_check:
			ds->state.last_check = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_state_last_state_change:
			ds->state.last_state_change = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_state_last_hard_state_change:
			ds->state.last_hard_state_change = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_state_last_time_up:
			ds->state.last_time_up = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_state_last_time_down:
			ds->state.last_time_down = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_state_last_time_unreachable:
			ds->state.last_time_unreachable = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_state_has_been_checked:
			ds->state.has_been_checked = atoi(kv->value);
			break;
		case NEBEV_COL_state_current_notification_number:
			ds->state.current_notification_number = atoi(kv->value);
			break;
		case NEBEV_COL_state_current_notification_id:
			ds->state.current_notification_id = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_state_check_flapping_recovery_notification:
			ds->state.check_flapping_recovery_notification = atoi(kv->value);
			break;
		case NEBEV_COL_state_scheduled_downtime_depth:
			ds->state.scheduled_downtime_depth = atoi(kv->value);
			break;
		case NEBEV_COL_state_pending_flex_downtime:
			ds->state.pending_flex_downtime = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_0_:
			ds->state.state_history[0] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_1_:
			ds->state.state_history[1] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_2_:
			ds->state.state_history[2] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_3_:
			ds->state.state_history[3] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_4_:
			ds->state.state_history[4] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_5_:
			ds->state.state_history[5] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_6_:
			ds->state.state_history[6] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_7_:
			ds->state.state_history[7] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_8_:
			ds->state.state_history[8] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_9_:
			ds->state.state_history[9] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_10_:
			ds->state.state_history[10] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_11_:
			ds->state.state_history[11] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_12_:
			ds->state.state_history[12] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_13_:
			ds->state.state_history[13] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_14_:
			ds->state.state_history[14] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_15_:
			ds->state.state_history[15] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_16_:
			ds->state.state_history[16] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_17_:
			ds->state.state_history[17] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_18_:
			ds->state.state_history[18] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_19_:
			ds->state.state_history[19] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_20_:
			ds->state.state_history[20] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_index:
			ds->state.state_history_index = atoi(kv->value);
			break;
		case NEBEV_COL_state_is_flapping:
			ds->state.is_flapping = atoi(kv->value);
			break;
		case NEBEV_COL_state_flapping_comment_id:
			ds->state.flapping_comment_id = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_state_percent_state_change:
			ds->state.percent_state_change = strtod(kv->value, &endptr);
			break;
		case NEBEV_COL_state_modified_attributes:
			ds->state.modified_attributes = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_state_notified_on:
			ds->state.notified_on = atoi(kv->value);
			break;
		case NEBEV_COL_state_plugin_output:
			ds->state.plugin_output = kv->value;
			break;
		case NEBEV_COL_state_long_plugin_output:
			ds->state.long_plugin_output = kv->value;
			break;
		case NEBEV_COL_state_perf_data:
			ds->state.perf_data = kv->value;
			break;
		case NEBEV_COL_name:
			ds->name = kv->value;
			break;
		default:
			printf("Unrecognized key for this event type '%s'\n", kv->key);
			return -1;
		}
	}

	return 0;
}

int kvvec_to_statechange(struct kvvec *kvv, void *data)
{
	nebstruct_statechange_data *ds;
	int i;

	ds = (nebstruct_statechange_data *)data;
	for (i = 0; i < kvv->kv_pairs; i++) {
		struct key_value *kv = &kvv->kv[i];
		const struct nebev_column_code *keycode;
		char *endptr;

		keycode = nebev_col_key(kv->key, kv->key_len);
		if (!keycode) {
			printf("%s is not a valid nebevent column\n", kv->key);
			return 1 + i;
		}

		switch (keycode->code) {
		case NEBEV_COL_timestamp:
			ds->timestamp.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->timestamp.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_attr:
			ds->attr = atoi(kv->value);
			break;
		case NEBEV_COL_flags:
			ds->flags = atoi(kv->value);
			break;
		case NEBEV_COL_type:
			ds->type = atoi(kv->value);
			break;
		case NEBEV_COL_statechange_type:
			ds->statechange_type = atoi(kv->value);
			break;
		case NEBEV_COL_host_name:
			ds->host_name = kv->value;
			break;
		case NEBEV_COL_service_description:
			ds->service_description = kv->value;
			break;
		case NEBEV_COL_state:
			ds->state = atoi(kv->value);
			break;
		case NEBEV_COL_state_type:
			ds->state_type = atoi(kv->value);
			break;
		case NEBEV_COL_current_attempt:
			ds->current_attempt = atoi(kv->value);
			break;
		case NEBEV_COL_max_attempts:
			ds->max_attempts = atoi(kv->value);
			break;
		case NEBEV_COL_output:
			ds->output = kv->value;
			break;
		default:
			printf("Unrecognized key for this event type '%s'\n", kv->key);
			return -1;
		}
	}

	return 0;
}

int kvvec_to_contact_status(struct kvvec *kvv, void *data)
{
	nebstruct_contact_status_data *ds;
	int i;

	ds = (nebstruct_contact_status_data *)data;
	for (i = 0; i < kvv->kv_pairs; i++) {
		struct key_value *kv = &kvv->kv[i];
		const struct nebev_column_code *keycode;
		char *endptr;

		keycode = nebev_col_key(kv->key, kv->key_len);
		if (!keycode) {
			printf("%s is not a valid nebevent column\n", kv->key);
			return 1 + i;
		}

		switch (keycode->code) {
		case NEBEV_COL_timestamp:
			ds->timestamp.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->timestamp.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_attr:
			ds->attr = atoi(kv->value);
			break;
		case NEBEV_COL_flags:
			ds->flags = atoi(kv->value);
			break;
		case NEBEV_COL_type:
			ds->type = atoi(kv->value);
			break;
		default:
			printf("Unrecognized key for this event type '%s'\n", kv->key);
			return -1;
		}
	}

	return 0;
}

int kvvec_to_retention(struct kvvec *kvv, void *data)
{
	nebstruct_retention_data *ds;
	int i;

	ds = (nebstruct_retention_data *)data;
	for (i = 0; i < kvv->kv_pairs; i++) {
		struct key_value *kv = &kvv->kv[i];
		const struct nebev_column_code *keycode;
		char *endptr;

		keycode = nebev_col_key(kv->key, kv->key_len);
		if (!keycode) {
			printf("%s is not a valid nebevent column\n", kv->key);
			return 1 + i;
		}

		switch (keycode->code) {
		case NEBEV_COL_timestamp:
			ds->timestamp.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->timestamp.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_attr:
			ds->attr = atoi(kv->value);
			break;
		case NEBEV_COL_flags:
			ds->flags = atoi(kv->value);
			break;
		case NEBEV_COL_type:
			ds->type = atoi(kv->value);
			break;
		default:
			printf("Unrecognized key for this event type '%s'\n", kv->key);
			return -1;
		}
	}

	return 0;
}

int kvvec_to_service_check(struct kvvec *kvv, void *data)
{
	nebstruct_service_check_data *ds;
	int i;

	ds = (nebstruct_service_check_data *)data;
	for (i = 0; i < kvv->kv_pairs; i++) {
		struct key_value *kv = &kvv->kv[i];
		const struct nebev_column_code *keycode;
		char *endptr;

		keycode = nebev_col_key(kv->key, kv->key_len);
		if (!keycode) {
			printf("%s is not a valid nebevent column\n", kv->key);
			return 1 + i;
		}

		switch (keycode->code) {
		case NEBEV_COL_timestamp:
			ds->timestamp.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->timestamp.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_attr:
			ds->attr = atoi(kv->value);
			break;
		case NEBEV_COL_flags:
			ds->flags = atoi(kv->value);
			break;
		case NEBEV_COL_type:
			ds->type = atoi(kv->value);
			break;
		case NEBEV_COL_host_name:
			ds->host_name = kv->value;
			break;
		case NEBEV_COL_service_description:
			ds->service_description = kv->value;
			break;
		case NEBEV_COL_check_type:
			ds->check_type = atoi(kv->value);
			break;
		case NEBEV_COL_current_attempt:
			ds->current_attempt = atoi(kv->value);
			break;
		case NEBEV_COL_max_attempts:
			ds->max_attempts = atoi(kv->value);
			break;
		case NEBEV_COL_state_type:
			ds->state_type = atoi(kv->value);
			break;
		case NEBEV_COL_state:
			ds->state = atoi(kv->value);
			break;
		case NEBEV_COL_timeout:
			ds->timeout = atoi(kv->value);
			break;
		case NEBEV_COL_command_name:
			ds->command_name = kv->value;
			break;
		case NEBEV_COL_command_args:
			ds->command_args = kv->value;
			break;
		case NEBEV_COL_command_line:
			ds->command_line = kv->value;
			break;
		case NEBEV_COL_start_time:
			ds->start_time.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->start_time.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_end_time:
			ds->end_time.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->end_time.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_early_timeout:
			ds->early_timeout = atoi(kv->value);
			break;
		case NEBEV_COL_execution_time:
			ds->execution_time = strtod(kv->value, &endptr);
			break;
		case NEBEV_COL_latency:
			ds->latency = strtod(kv->value, &endptr);
			break;
		case NEBEV_COL_return_code:
			ds->return_code = atoi(kv->value);
			break;
		case NEBEV_COL_output:
			ds->output = kv->value;
			break;
		case NEBEV_COL_long_output:
			ds->long_output = kv->value;
			break;
		case NEBEV_COL_perf_data:
			ds->perf_data = kv->value;
			break;
		default:
			printf("Unrecognized key for this event type '%s'\n", kv->key);
			return -1;
		}
	}

	return 0;
}

int kvvec_to_acknowledgement(struct kvvec *kvv, void *data)
{
	nebstruct_acknowledgement_data *ds;
	int i;

	ds = (nebstruct_acknowledgement_data *)data;
	for (i = 0; i < kvv->kv_pairs; i++) {
		struct key_value *kv = &kvv->kv[i];
		const struct nebev_column_code *keycode;
		char *endptr;

		keycode = nebev_col_key(kv->key, kv->key_len);
		if (!keycode) {
			printf("%s is not a valid nebevent column\n", kv->key);
			return 1 + i;
		}

		switch (keycode->code) {
		case NEBEV_COL_timestamp:
			ds->timestamp.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->timestamp.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_attr:
			ds->attr = atoi(kv->value);
			break;
		case NEBEV_COL_flags:
			ds->flags = atoi(kv->value);
			break;
		case NEBEV_COL_type:
			ds->type = atoi(kv->value);
			break;
		case NEBEV_COL_acknowledgement_type:
			ds->acknowledgement_type = atoi(kv->value);
			break;
		case NEBEV_COL_host_name:
			ds->host_name = kv->value;
			break;
		case NEBEV_COL_service_description:
			ds->service_description = kv->value;
			break;
		case NEBEV_COL_state:
			ds->state = atoi(kv->value);
			break;
		case NEBEV_COL_author_name:
			ds->author_name = kv->value;
			break;
		case NEBEV_COL_comment_data:
			ds->comment_data = kv->value;
			break;
		case NEBEV_COL_is_sticky:
			ds->is_sticky = atoi(kv->value);
			break;
		case NEBEV_COL_persistent_comment:
			ds->persistent_comment = atoi(kv->value);
			break;
		case NEBEV_COL_notify_contacts:
			ds->notify_contacts = atoi(kv->value);
			break;
		default:
			printf("Unrecognized key for this event type '%s'\n", kv->key);
			return -1;
		}
	}

	return 0;
}

int kvvec_to_host_status(struct kvvec *kvv, void *data)
{
	nebstruct_host_status_data *ds;
	int i;

	ds = (nebstruct_host_status_data *)data;
	for (i = 0; i < kvv->kv_pairs; i++) {
		struct key_value *kv = &kvv->kv[i];
		const struct nebev_column_code *keycode;
		char *endptr;

		keycode = nebev_col_key(kv->key, kv->key_len);
		if (!keycode) {
			printf("%s is not a valid nebevent column\n", kv->key);
			return 1 + i;
		}

		switch (keycode->code) {
		case NEBEV_COL_timestamp:
			ds->timestamp.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->timestamp.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_attr:
			ds->attr = atoi(kv->value);
			break;
		case NEBEV_COL_flags:
			ds->flags = atoi(kv->value);
			break;
		case NEBEV_COL_type:
			ds->type = atoi(kv->value);
			break;
		default:
			printf("Unrecognized key for this event type '%s'\n", kv->key);
			return -1;
		}
	}

	return 0;
}

int kvvec_to_aggregated_status(struct kvvec *kvv, void *data)
{
	nebstruct_aggregated_status_data *ds;
	int i;

	ds = (nebstruct_aggregated_status_data *)data;
	for (i = 0; i < kvv->kv_pairs; i++) {
		struct key_value *kv = &kvv->kv[i];
		const struct nebev_column_code *keycode;
		char *endptr;

		keycode = nebev_col_key(kv->key, kv->key_len);
		if (!keycode) {
			printf("%s is not a valid nebevent column\n", kv->key);
			return 1 + i;
		}

		switch (keycode->code) {
		case NEBEV_COL_timestamp:
			ds->timestamp.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->timestamp.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_attr:
			ds->attr = atoi(kv->value);
			break;
		case NEBEV_COL_flags:
			ds->flags = atoi(kv->value);
			break;
		case NEBEV_COL_type:
			ds->type = atoi(kv->value);
			break;
		default:
			printf("Unrecognized key for this event type '%s'\n", kv->key);
			return -1;
		}
	}

	return 0;
}

int kvvec_to_host_check(struct kvvec *kvv, void *data)
{
	nebstruct_host_check_data *ds;
	int i;

	ds = (nebstruct_host_check_data *)data;
	for (i = 0; i < kvv->kv_pairs; i++) {
		struct key_value *kv = &kvv->kv[i];
		const struct nebev_column_code *keycode;
		char *endptr;

		keycode = nebev_col_key(kv->key, kv->key_len);
		if (!keycode) {
			printf("%s is not a valid nebevent column\n", kv->key);
			return 1 + i;
		}

		switch (keycode->code) {
		case NEBEV_COL_timestamp:
			ds->timestamp.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->timestamp.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_attr:
			ds->attr = atoi(kv->value);
			break;
		case NEBEV_COL_flags:
			ds->flags = atoi(kv->value);
			break;
		case NEBEV_COL_type:
			ds->type = atoi(kv->value);
			break;
		case NEBEV_COL_host_name:
			ds->host_name = kv->value;
			break;
		case NEBEV_COL_current_attempt:
			ds->current_attempt = atoi(kv->value);
			break;
		case NEBEV_COL_check_type:
			ds->check_type = atoi(kv->value);
			break;
		case NEBEV_COL_max_attempts:
			ds->max_attempts = atoi(kv->value);
			break;
		case NEBEV_COL_state_type:
			ds->state_type = atoi(kv->value);
			break;
		case NEBEV_COL_state:
			ds->state = atoi(kv->value);
			break;
		case NEBEV_COL_timeout:
			ds->timeout = atoi(kv->value);
			break;
		case NEBEV_COL_command_name:
			ds->command_name = kv->value;
			break;
		case NEBEV_COL_command_args:
			ds->command_args = kv->value;
			break;
		case NEBEV_COL_command_line:
			ds->command_line = kv->value;
			break;
		case NEBEV_COL_start_time:
			ds->start_time.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->start_time.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_end_time:
			ds->end_time.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->end_time.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_early_timeout:
			ds->early_timeout = atoi(kv->value);
			break;
		case NEBEV_COL_execution_time:
			ds->execution_time = strtod(kv->value, &endptr);
			break;
		case NEBEV_COL_latency:
			ds->latency = strtod(kv->value, &endptr);
			break;
		case NEBEV_COL_return_code:
			ds->return_code = atoi(kv->value);
			break;
		case NEBEV_COL_output:
			ds->output = kv->value;
			break;
		case NEBEV_COL_long_output:
			ds->long_output = kv->value;
			break;
		case NEBEV_COL_perf_data:
			ds->perf_data = kv->value;
			break;
		default:
			printf("Unrecognized key for this event type '%s'\n", kv->key);
			return -1;
		}
	}

	return 0;
}

int kvvec_to_merlin_service_status(struct kvvec *kvv, void *data)
{
	merlin_service_status *ds;
	int i;

	ds = (merlin_service_status *)data;
	for (i = 0; i < kvv->kv_pairs; i++) {
		struct key_value *kv = &kvv->kv[i];
		const struct nebev_column_code *keycode;
		char *endptr;

		keycode = nebev_col_key(kv->key, kv->key_len);
		if (!keycode) {
			printf("%s is not a valid nebevent column\n", kv->key);
			return 1 + i;
		}

		switch (keycode->code) {
		case NEBEV_COL_nebattr:
			ds->nebattr = atoi(kv->value);
			break;
		case NEBEV_COL_state_initial_state:
			ds->state.initial_state = atoi(kv->value);
			break;
		case NEBEV_COL_state_flap_detection_enabled:
			ds->state.flap_detection_enabled = atoi(kv->value);
			break;
		case NEBEV_COL_state_low_flap_threshold:
			ds->state.low_flap_threshold = strtod(kv->value, &endptr);
			break;
		case NEBEV_COL_state_high_flap_threshold:
			ds->state.high_flap_threshold = strtod(kv->value, &endptr);
			break;
		case NEBEV_COL_state_check_freshness:
			ds->state.check_freshness = atoi(kv->value);
			break;
		case NEBEV_COL_state_freshness_threshold:
			ds->state.freshness_threshold = atoi(kv->value);
			break;
		case NEBEV_COL_state_process_performance_data:
			ds->state.process_performance_data = atoi(kv->value);
			break;
		case NEBEV_COL_state_checks_enabled:
			ds->state.checks_enabled = atoi(kv->value);
			break;
		case NEBEV_COL_state_accept_passive_checks:
			ds->state.accept_passive_checks = atoi(kv->value);
			break;
		case NEBEV_COL_state_event_handler_enabled:
			ds->state.event_handler_enabled = atoi(kv->value);
			break;
		case NEBEV_COL_state_obsess:
			ds->state.obsess = atoi(kv->value);
			break;
		case NEBEV_COL_state_problem_has_been_acknowledged:
			ds->state.problem_has_been_acknowledged = atoi(kv->value);
			break;
		case NEBEV_COL_state_acknowledgement_type:
			ds->state.acknowledgement_type = atoi(kv->value);
			break;
		case NEBEV_COL_state_check_type:
			ds->state.check_type = atoi(kv->value);
			break;
		case NEBEV_COL_state_current_state:
			ds->state.current_state = atoi(kv->value);
			break;
		case NEBEV_COL_state_last_state:
			ds->state.last_state = atoi(kv->value);
			break;
		case NEBEV_COL_state_last_hard_state:
			ds->state.last_hard_state = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_type:
			ds->state.state_type = atoi(kv->value);
			break;
		case NEBEV_COL_state_current_attempt:
			ds->state.current_attempt = atoi(kv->value);
			break;
		case NEBEV_COL_state_hourly_value:
			ds->state.hourly_value = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_state_current_event_id:
			ds->state.current_event_id = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_state_last_event_id:
			ds->state.last_event_id = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_state_current_problem_id:
			ds->state.current_problem_id = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_state_last_problem_id:
			ds->state.last_problem_id = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_state_latency:
			ds->state.latency = strtod(kv->value, &endptr);
			break;
		case NEBEV_COL_state_execution_time:
			ds->state.execution_time = strtod(kv->value, &endptr);
			break;
		case NEBEV_COL_state_notifications_enabled:
			ds->state.notifications_enabled = atoi(kv->value);
			break;
		case NEBEV_COL_state_last_notification:
			ds->state.last_notification = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_state_next_notification:
			ds->state.next_notification = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_state_next_check:
			ds->state.next_check = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_state_should_be_scheduled:
			ds->state.should_be_scheduled = atoi(kv->value);
			break;
		case NEBEV_COL_state_last_check:
			ds->state.last_check = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_state_last_state_change:
			ds->state.last_state_change = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_state_last_hard_state_change:
			ds->state.last_hard_state_change = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_state_last_time_up:
			ds->state.last_time_up = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_state_last_time_down:
			ds->state.last_time_down = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_state_last_time_unreachable:
			ds->state.last_time_unreachable = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_state_has_been_checked:
			ds->state.has_been_checked = atoi(kv->value);
			break;
		case NEBEV_COL_state_current_notification_number:
			ds->state.current_notification_number = atoi(kv->value);
			break;
		case NEBEV_COL_state_current_notification_id:
			ds->state.current_notification_id = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_state_check_flapping_recovery_notification:
			ds->state.check_flapping_recovery_notification = atoi(kv->value);
			break;
		case NEBEV_COL_state_scheduled_downtime_depth:
			ds->state.scheduled_downtime_depth = atoi(kv->value);
			break;
		case NEBEV_COL_state_pending_flex_downtime:
			ds->state.pending_flex_downtime = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_0_:
			ds->state.state_history[0] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_1_:
			ds->state.state_history[1] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_2_:
			ds->state.state_history[2] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_3_:
			ds->state.state_history[3] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_4_:
			ds->state.state_history[4] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_5_:
			ds->state.state_history[5] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_6_:
			ds->state.state_history[6] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_7_:
			ds->state.state_history[7] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_8_:
			ds->state.state_history[8] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_9_:
			ds->state.state_history[9] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_10_:
			ds->state.state_history[10] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_11_:
			ds->state.state_history[11] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_12_:
			ds->state.state_history[12] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_13_:
			ds->state.state_history[13] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_14_:
			ds->state.state_history[14] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_15_:
			ds->state.state_history[15] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_16_:
			ds->state.state_history[16] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_17_:
			ds->state.state_history[17] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_18_:
			ds->state.state_history[18] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_19_:
			ds->state.state_history[19] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_20_:
			ds->state.state_history[20] = atoi(kv->value);
			break;
		case NEBEV_COL_state_state_history_index:
			ds->state.state_history_index = atoi(kv->value);
			break;
		case NEBEV_COL_state_is_flapping:
			ds->state.is_flapping = atoi(kv->value);
			break;
		case NEBEV_COL_state_flapping_comment_id:
			ds->state.flapping_comment_id = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_state_percent_state_change:
			ds->state.percent_state_change = strtod(kv->value, &endptr);
			break;
		case NEBEV_COL_state_modified_attributes:
			ds->state.modified_attributes = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_state_notified_on:
			ds->state.notified_on = atoi(kv->value);
			break;
		case NEBEV_COL_state_plugin_output:
			ds->state.plugin_output = kv->value;
			break;
		case NEBEV_COL_state_long_plugin_output:
			ds->state.long_plugin_output = kv->value;
			break;
		case NEBEV_COL_state_perf_data:
			ds->state.perf_data = kv->value;
			break;
		case NEBEV_COL_host_name:
			ds->host_name = kv->value;
			break;
		case NEBEV_COL_service_description:
			ds->service_description = kv->value;
			break;
		default:
			printf("Unrecognized key for this event type '%s'\n", kv->key);
			return -1;
		}
	}

	return 0;
}

int kvvec_to_merlin_nodeinfo(struct kvvec *kvv, void *data)
{
	merlin_nodeinfo *ds;
	int i;

	ds = (merlin_nodeinfo *)data;
	for (i = 0; i < kvv->kv_pairs; i++) {
		struct key_value *kv = &kvv->kv[i];
		const struct nebev_column_code *keycode;
		char *endptr;

		keycode = nebev_col_key(kv->key, kv->key_len);
		if (!keycode) {
			printf("%s is not a valid nebevent column\n", kv->key);
			return 1 + i;
		}

		switch (keycode->code) {
		case NEBEV_COL_version:
			ds->version = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_word_size:
			ds->word_size = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_byte_order:
			ds->byte_order = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_object_structure_version:
			ds->object_structure_version = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_start:
			ds->start.tv_sec = strtoul(kv->value, &endptr, 10);
			ds->start.tv_usec = strtoul(endptr + 1, NULL, 10);
			break;
		case NEBEV_COL_last_cfg_change:
			ds->last_cfg_change = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_config_hash:
			memcpy(ds->config_hash, kv->value, (20 > kv->value_len) ? kv->value_len : 20);
			break;
		case NEBEV_COL_peer_id:
			ds->peer_id = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_active_peers:
			ds->active_peers = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_configured_peers:
			ds->configured_peers = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_active_pollers:
			ds->active_pollers = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_configured_pollers:
			ds->configured_pollers = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_active_masters:
			ds->active_masters = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_configured_masters:
			ds->configured_masters = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_host_checks_handled:
			ds->host_checks_handled = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_service_checks_handled:
			ds->service_checks_handled = strtoul(kv->value, &endptr, 10);
			break;
		case NEBEV_COL_monitored_object_state_size:
			ds->monitored_object_state_size = strtoul(kv->value, &endptr, 10);
			break;
		default:
			printf("Unrecognized key for this event type '%s'\n", kv->key);
			return -1;
		}
	}

	return 0;
}
